Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.28.6.1
retrieving revision 1.28.6.1.4.1
diff -u -r1.28.6.1 -r1.28.6.1.4.1
--- squid/src/main.c	16 Jan 2002 09:32:28 -0000	1.28.6.1
+++ squid/src/main.c	14 Mar 2002 20:23:44 -0000	1.28.6.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.28.6.1 2002/01/16 09:32:28 squidadm Exp $
+ * $Id: main.c,v 1.28.6.1.4.1 2002/03/14 20:23:44 serassio Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -35,11 +35,26 @@
 
 #include "squid.h"
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+#include <windows.h>
+#include <process.h>
+static int opt_install_service = FALSE;
+static int opt_remove_service = FALSE;
+static int opt_signal_service = FALSE;
+static int opt_command_line = FALSE;
+extern void WIN32_svcstatusupdate(DWORD);
+void WINAPI WIN32_svcHandler(DWORD);
+#endif
+
 /* for error reporting from xmalloc and friends */
 extern void (*failure_notify) (const char *);
 
 static int opt_send_signal = -1;
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+static int opt_no_daemon = 1;
+#else
 static int opt_no_daemon = 0;
+#endif
 static int opt_parse_cfg_only = 0;
 static int httpPortNumOverride = 1;
 static int icpPortNumOverride = 1;	/* Want to detect "-u 0" */
@@ -53,8 +68,6 @@
 
 static void mainRotate(void);
 static void mainReconfigure(void);
-static SIGHDLR rotate_logs;
-static SIGHDLR reconfigure;
 #if ALARM_UPDATES_TIME
 static SIGHDLR time_tick;
 #endif
@@ -83,15 +96,27 @@
 usage(void)
 {
     fprintf(stderr,
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"Usage: %s [-dhirsvzCDFRVYX] [-f config-file] [-[au] port] [-k signal] [-n name] [-O CommandLine]\n"
+#else
 	"Usage: %s [-dhsvzCDFNRVYX] [-f config-file] [-[au] port] [-k signal]\n"
+#endif
 	"       -a port   Specify HTTP port number (default: %d).\n"
 	"       -d level  Write debugging to stderr also.\n"
 	"       -f file   Use given config-file instead of\n"
 	"                 %s\n"
 	"       -h        Print help message.\n"
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"       -i        Installs as a Windows Service (see -n option).\n"
+#endif
 	"       -k reconfigure|rotate|shutdown|interrupt|kill|debug|check|parse\n"
 	"                 Parse configuration file, then send signal to \n"
 	"                 running copy (except -k parse) and exit.\n"
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"       -n name   Specify Windows Service name to use for service operations\n"
+	"                 default is: " _WIN_SQUID_DEFAULT_SERVICE_NAME ".\n"
+	"       -r        Removes a Windows Service (see -n option).\n"
+#endif
 	"       -s        Enable logging to syslog.\n"
 	"       -u port   Specify ICP port number (default: %d), disable with 0.\n"
 	"       -v        Print version.\n"
@@ -99,7 +124,12 @@
 	"       -C        Do not catch fatal signals.\n"
 	"       -D        Disable initial DNS tests.\n"
 	"       -F        Don't serve any requests until store is rebuilt.\n"
+#if !(defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)))
 	"       -N        No daemon mode.\n"
+#else
+	"       -O options\n"
+       	"                 Set Windows Service Command line options in Registry.\n"
+#endif
 	"       -R        Do not set REUSEADDR on port.\n"
 	"       -S        Double-check swap during rebuild.\n"
 	"       -V        Virtual host httpd-accelerator.\n"
@@ -115,7 +145,11 @@
     extern char *optarg;
     int c;
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    while ((c = getopt(argc, argv, "CDFO:RSVYXa:d:f:hik:m::n:rsu:vz?")) != -1) {
+#else
     while ((c = getopt(argc, argv, "CDFNRSVYXa:d:f:hk:m::su:vz?")) != -1) {
+#endif
 	switch (c) {
 	case 'C':
 	    opt_catch_signals = 0;
@@ -126,9 +160,16 @@
 	case 'F':
 	    opt_foreground_rebuild = 1;
 	    break;
+#if !(defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)))
 	case 'N':
 	    opt_no_daemon = 1;
 	    break;
+#else
+	case 'O':
+	    opt_command_line = 1;
+	    WIN32_Command_Line = xstrdup(optarg);
+	    break;
+#endif
 	case 'R':
 	    opt_reuseaddr = 0;
 	    break;
@@ -158,6 +199,11 @@
 	case 'h':
 	    usage();
 	    break;
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	case 'i':
+	    opt_install_service = TRUE;
+	    break;
+#endif
 	case 'k':
 	    if ((int) strlen(optarg) < 1)
 		usage();
@@ -205,6 +251,16 @@
 		fatal("Need to configure --enable-xmalloc-debug-trace to use -m option");
 #endif
 	    }
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	case 'n':
+	    xfree(WIN32_Service_name);
+	    WIN32_Service_name = xstrdup(optarg);
+	    opt_signal_service = TRUE;
+	    break;
+	case 'r':
+	    opt_remove_service = TRUE;
+	    break;
+#endif
 	case 's':
 	    opt_syslog_enable = 1;
 	    break;
@@ -215,6 +271,9 @@
 	    break;
 	case 'v':
 	    printf("Squid Cache: Version %s\nconfigure options: %s\n", version_string, SQUID_CONFIGURE_OPTIONS);
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    printf("Compiled as Windows System Service.\n");
+#endif
 	    exit(0);
 	    /* NOTREACHED */
 	case 'z':
@@ -229,13 +288,15 @@
 }
 
 /* ARGSUSED */
-static void
+void
 rotate_logs(int sig)
 {
     do_rotate = 1;
+#ifndef _SQUID_MSWIN_
 #if !HAVE_SIGACTION
     signal(sig, rotate_logs);
 #endif
+#endif
 }
 
 #if ALARM_UPDATES_TIME
@@ -252,19 +313,22 @@
 #endif
 
 /* ARGSUSED */
-static void
+void
 reconfigure(int sig)
 {
     do_reconfigure = 1;
+#ifndef _SQUID_MSWIN_
 #if !HAVE_SIGACTION
     signal(sig, reconfigure);
 #endif
+#endif
 }
 
 void
 shut_down(int sig)
 {
     do_shutdown = sig == SIGINT ? -1 : 1;
+#ifndef _SQUID_MSWIN_
 #ifdef KILL_PARENT_OPT
     if (getppid() > 1) {
 	debug(1, 1) ("Killing RunCache, pid %d\n", getppid());
@@ -275,6 +339,7 @@
     signal(SIGTERM, SIG_DFL);
     signal(SIGINT, SIG_DFL);
 #endif
+#endif
 }
 
 static void
@@ -292,7 +357,9 @@
     wccpConnectionOpen();
 #endif
     clientdbInit();
+#ifndef _SQUID_MSWIN_
     icmpOpen();
+#endif
     netdbInit();
     asnInit();
     peerSelectInit();
@@ -411,7 +478,7 @@
     leave_suid();		/* Run as non privilegied user */
 #ifdef _SQUID_OS2_
     return;
-#endif
+#else
     if (geteuid() == 0) {
 	debug(0, 0) ("Squid is not safe to run as root!  If you must\n");
 	debug(0, 0) ("start Squid as root, then you must configure\n");
@@ -419,6 +486,7 @@
 	debug(0, 0) ("'cache_effective_user' option in the config file.\n");
 	fatal("Don't run Squid as root, set 'cache_effective_user'!");
     }
+#endif
 }
 
 static void
@@ -472,6 +540,14 @@
     debug(1, 0) ("Starting Squid Cache version %s for %s...\n",
 	version_string,
 	CONFIG_HOST_TYPE);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	debug(1, 0) ("Running as %s Windows System Service on %s\n", WIN32_Service_name, WIN32_OS_string);
+	debug(1, 0) ("Service command line is: %s\n", WIN32_Service_Command_Line);
+    }
+    else
+	debug(1, 0) ("Running on %s\n",WIN32_OS_string);
+#endif
     debug(1, 1) ("Process ID %d\n", (int) getpid());
     debug(1, 1) ("With %d file descriptors available\n", Squid_MaxFD);
 
@@ -563,24 +639,35 @@
     configured_once = 1;
 }
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+/* When USE_WIN32_SERVICE is defined, the main function is placed in win32.c */
+void WINAPI
+SquidMain(int argc, char **argv)
+#else
 int
 main(int argc, char **argv)
+#endif
 {
     int errcount = 0;
     int n;			/* # of GC'd objects */
     time_t loop_delay;
     mode_t oldmask;
-#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-    int WIN32_init_err;
-#endif
 
     debug_log = stderr;
     if (FD_SETSIZE < Squid_MaxFD)
 	Squid_MaxFD = FD_SETSIZE;
 
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-    if ((WIN32_init_err = WIN32_Subsystem_Init()))
-	return WIN32_init_err;
+#ifdef USE_WIN32_SERVICE
+    if (WIN32_Subsystem_Init(&argc, &argv))
+	return;
+#else
+    {
+	int WIN32_init_err;	
+	if ((WIN32_init_err = WIN32_Subsystem_Init()))
+	    return WIN32_init_err;
+    }
+#endif
 #endif
 
     /* call mallopt() before anything else */
@@ -621,8 +708,26 @@
     squid_start = current_time;
     failure_notify = fatal_dump;
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_START_PENDING);
+#endif
     mainParseOptions(argc, argv);
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    if (opt_install_service) {
+	WIN32_InstallService();
+	return;
+    }
+    if (opt_remove_service) {
+	WIN32_RemoveService();
+	return;
+    }
+    if (opt_command_line) {
+	WIN32_SetServiceCommandLine();
+	return;
+    }
+#endif
+
     /* parse configuration file
      * note: in "normal" case this used to be called from mainInitialize() */
     {
@@ -641,7 +746,11 @@
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    return;
+#else
 	    return parse_err;
+#endif
     }
     if (-1 == opt_send_signal)
 	if (checkRunningPid())
@@ -672,7 +781,11 @@
 	setEffectiveUser();
 	debug(0, 0) ("Creating Swap Directories\n");
 	storeCreateSwapDirectories();
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	return;
+#else
 	return 0;
+#endif
     }
     if (!opt_no_daemon)
 	watch_child(argv);
@@ -686,14 +799,25 @@
     comm_init();
     comm_select_init();
 
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if ((WIN32_run_mode == _WIN_SQUID_RUN_MODE_INTERACTIVE) && (opt_no_daemon)) {
+#else
     if (opt_no_daemon) {
+#endif
 	/* we have to init fdstat here. */
 	fd_open(0, FD_LOG, "stdin");
 	fd_open(1, FD_LOG, "stdout");
 	fd_open(2, FD_LOG, "stderr");
     }
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_START_PENDING);
+#endif
     mainInitialize();
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_RUNNING);
+#endif
+
     /* main loop */
     for (;;) {
 	if (do_reconfigure) {
@@ -711,6 +835,9 @@
 	    do_shutdown = 0;
 	    shutting_down = 1;
 	    serverConnectionsClose();
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    WIN32_svcstatusupdate(SERVICE_STOP_PENDING);
+#endif
 #if USE_DNSSERVERS
 	    dnsShutdown();
 #else
@@ -747,7 +874,11 @@
 	}
     }
     /* NOTREACHED */
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    return;
+#else
     return 0;
+#endif
 }
 
 static void
@@ -757,6 +888,11 @@
     debug_log = stderr;
     pid = readPidFile();
     if (pid > 1) {
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	if (opt_signal_service)
+	    WIN32_sendSignal(opt_send_signal);
+	else {
+#endif
 	if (kill(pid, opt_send_signal) &&
 	/* ignore permissions if just running check */
 	    !(opt_send_signal == 0 && errno == EPERM)) {
@@ -765,6 +901,9 @@
 		opt_send_signal, (int) pid, xstrerror());
 	    exit(1);
 	}
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	}
+#endif
     } else {
 	fprintf(stderr, "%s: ERROR: No running copy\n", appname);
 	exit(1);
@@ -773,6 +912,7 @@
     exit(0);
 }
 
+#ifndef _SQUID_MSWIN_
 /*
  * This function is run when Squid is in daemon mode, just
  * before the parent forks and starts up the child process.
@@ -809,6 +949,7 @@
 	} while (rpid != cpid);
     }
 }
+#endif
 
 static int
 checkRunningPid(void)
@@ -827,6 +968,7 @@
 static void
 watch_child(char *argv[])
 {
+#ifndef _SQUID_MSWIN_
     char *prog;
     int failcount = 0;
     time_t start;
@@ -928,6 +1070,7 @@
 	sleep(3);
     }
     /* NOTREACHED */
+#endif
 }
 
 static void
@@ -984,7 +1127,11 @@
     errorClean();
 #endif
 #if !XMALLOC_TRACE
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if ((WIN32_run_mode == _WIN_SQUID_RUN_MODE_INTERACTIVE) && (opt_no_daemon)) {
+#else
     if (opt_no_daemon) {
+#endif
 	file_close(0);
 	file_close(1);
 	file_close(2);
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.41.6.3
retrieving revision 1.41.6.3.4.1
diff -u -r1.41.6.3 -r1.41.6.3.4.1
--- squid/src/protos.h	18 Feb 2002 15:01:19 -0000	1.41.6.3
+++ squid/src/protos.h	14 Mar 2002 20:23:44 -0000	1.41.6.3.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.41.6.3 2002/02/18 15:01:19 squidadm Exp $
+ * $Id: protos.h,v 1.41.6.3.4.1 2002/03/14 20:23:44 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -787,6 +787,8 @@
 
 extern void serverConnectionsClose(void);
 extern void shut_down(int);
+extern void rotate_logs(int);
+extern void reconfigure(int);
 
 
 extern void start_announce(void *unused);
@@ -1202,7 +1204,11 @@
     const char *const args[],
     const char *name,
     int *rfd,
-    int *wfd);
+    int *wfd
+#ifdef _SQUID_MSWIN_
+    , HANDLE * hIpc, pid_t * ppid
+#endif
+);
 
 /* CacheDigest */
 extern CacheDigest *cacheDigestCreate(int capacity, int bpe);
@@ -1324,8 +1330,25 @@
 /* CygWin & Windows NT Port */
 /* win32.c */
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#ifdef USE_WIN32_SERVICE
+extern int WIN32_Subsystem_Init(int *, char ***);
+#else
 extern int WIN32_Subsystem_Init(void);
+#endif
+extern void WIN32_sendSignal(int);
+extern void WIN32_Abort(int);
 extern void WIN32_Exit(void);
+extern void WIN32_SetServiceCommandLine(void);
+extern void WIN32_InstallService(void);
+extern void WIN32_RemoveService(void);
+#if defined(_SQUID_MSWIN_) && !defined(COMM_C)
+#define comm_open(sock_type,proto,addr,port,flags,note) \
+	comm_open((sock_type), \
+		(sock_type) == SOCK_DGRAM ? IPPROTO_UDP : IPPROTO_TCP, \
+		(addr),(port),(flags),(note))
+#endif
+extern int WIN32_getrusage(int, struct rusage *);
+extern int WIN32_is_interface_down(const char *);
 #endif
 
 #endif /* SQUID_PROTOS_H */
Index: squid/src/squid.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/squid.h,v
retrieving revision 1.13.6.2
retrieving revision 1.13.6.2.4.1
diff -u -r1.13.6.2 -r1.13.6.2.4.1
--- squid/src/squid.h	8 Jan 2002 05:19:18 -0000	1.13.6.2
+++ squid/src/squid.h	14 Mar 2002 20:23:45 -0000	1.13.6.2.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: squid.h,v 1.13.6.2 2002/01/08 05:19:18 squidadm Exp $
+ * $Id: squid.h,v 1.13.6.2.4.1 2002/03/14 20:23:45 serassio Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -211,7 +211,7 @@
 #if HAVE_LIMITS_H
 #include <limits.h>
 #endif
-#if defined(_SQUID_CYGWIN_)
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 #include <io.h>
 #endif
 
@@ -479,5 +479,13 @@
 
 #define FD_READ_METHOD(fd, buf, len) (*fd_table[fd].read_method)(fd, buf, len)
 #define FD_WRITE_METHOD(fd, buf, len) (*fd_table[fd].write_method)(fd, buf, len)
+
+#ifndef IPPROTO_UDP
+#define IPPROTO_UDP 0
+#endif
+
+#ifndef IPPROTO_TCP
+#define IPPROTO_TCP 0
+#endif
 
 #endif /* SQUID_H */
Index: squid/src/stat.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/stat.c,v
retrieving revision 1.13
retrieving revision 1.13.10.1
diff -u -r1.13 -r1.13.10.1
--- squid/src/stat.c	24 Oct 2001 09:42:13 -0000	1.13
+++ squid/src/stat.c	14 Mar 2002 20:23:45 -0000	1.13.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: stat.c,v 1.13 2001/10/24 09:42:13 squidadm Exp $
+ * $Id: stat.c,v 1.13.10.1 2002/03/14 20:23:45 serassio Exp $
  *
  * DEBUG: section 18    Cache Manager Statistics
  * AUTHOR: Harvest Derived
@@ -459,6 +459,15 @@
 	runtime = 1.0;
     storeAppendPrintf(sentry, "Squid Object Cache: Version %s\n",
 	version_string);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	storeAppendPrintf(sentry,"\nRunning as %s Windows System Service on %s\n",
+	WIN32_Service_name, WIN32_OS_string);
+	storeAppendPrintf(sentry,"Service command line is: %s\n", WIN32_Service_Command_Line);
+    }
+    else
+	storeAppendPrintf(sentry,"Running on %s\n",WIN32_OS_string);
+#endif
     storeAppendPrintf(sentry, "Start Time:\t%s\n",
 	mkrfc1123(squid_start.tv_sec));
     storeAppendPrintf(sentry, "Current Time:\t%s\n",
Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.19
retrieving revision 1.19.14.1
diff -u -r1.19 -r1.19.14.1
--- squid/src/store_dir.c	24 Oct 2001 09:42:14 -0000	1.19
+++ squid/src/store_dir.c	14 Mar 2002 20:23:45 -0000	1.19.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.19 2001/10/24 09:42:14 squidadm Exp $
+ * $Id: store_dir.c,v 1.19.14.1 2002/03/14 20:23:45 serassio Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -32,7 +32,8 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
  *
  */
-
+#ifndef STORE_DIR_C
+#define STORE_DIR_C
 #include "squid.h"
 
 #if HAVE_STATVFS
@@ -78,13 +79,18 @@
 {
     int i;
     SwapDir *sd;
+#ifndef _SQUID_MSWIN_
     pid_t pid;
     int status;
+#endif
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+#ifndef _SQUID_MSWIN_
 	if (fork())
 	    continue;
+#endif
 	sd = &Config.cacheSwap.swapDirs[i];
 	sd->newfs(sd);
+#ifndef _SQUID_MSWIN_
 	exit(0);
     }
     do {
@@ -94,6 +100,9 @@
 	pid = waitpid(-1, &status, 0);
 #endif
     } while (pid > 0 || (pid < 0 && errno == EINTR));
+#else
+    }
+#endif
 }
 
 /*
@@ -542,3 +551,4 @@
 #endif
     return 0;
 }
+#endif
Index: squid/src/store_io.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_io.c,v
retrieving revision 1.3
retrieving revision 1.3.14.1
diff -u -r1.3 -r1.3.14.1
--- squid/src/store_io.c	24 Oct 2001 09:42:14 -0000	1.3
+++ squid/src/store_io.c	14 Mar 2002 20:23:45 -0000	1.3.14.1
@@ -1,3 +1,5 @@
+#ifndef STORE_IO_C
+#define STORE_IO_C
 #include "squid.h"
 
 static struct {
@@ -115,3 +117,4 @@
     storeAppendPrintf(sentry, "create.create_fail %d\n", store_io_stats.create.create_fail);
     storeAppendPrintf(sentry, "create.success %d\n", store_io_stats.create.success);
 }
+#endif
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.48
retrieving revision 1.48.6.1
diff -u -r1.48 -r1.48.6.1
--- squid/src/structs.h	1 Dec 2001 20:27:54 -0000	1.48
+++ squid/src/structs.h	14 Mar 2002 20:23:45 -0000	1.48.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.48 2001/12/01 20:27:54 squidadm Exp $
+ * $Id: structs.h,v 1.48.6.1 2002/03/14 20:23:45 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -748,6 +748,9 @@
     unsigned int type;
     u_short local_port;
     u_short remote_port;
+#ifdef _SQUID_MSWIN_
+    FILE * fbuf;
+#endif
     struct in_addr local_addr;
     unsigned char tos;
     char ipaddr[16];		/* dotted decimal address of peer */
@@ -2051,6 +2054,10 @@
     struct {
 	int uses;
     } stats;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+#endif
 };
 
 
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.19
retrieving revision 1.19.14.1
diff -u -r1.19 -r1.19.14.1
--- squid/src/tools.c	18 Nov 2001 01:15:42 -0000	1.19
+++ squid/src/tools.c	14 Mar 2002 20:23:46 -0000	1.19.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.19 2001/11/18 01:15:42 squidadm Exp $
+ * $Id: tools.c,v 1.19.14.1 2002/03/14 20:23:46 serassio Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -305,6 +305,10 @@
 void
 sigusr2_handle(int sig)
 {
+#if defined(_SQUID_MSWIN_) && defined(_DEBUG)
+    do_debug = 1;
+#endif
+#if (defined(_SQUID_MSWIN_) && !defined(_DEBUG)) || !defined(_SQUID_MSWIN_)
     static int state = 0;
     /* no debug() here; bad things happen if the signal is delivered during _db_print() */
     if (state == 0) {
@@ -322,6 +326,7 @@
 #endif
 	state = 0;
     }
+#endif
 #if !HAVE_SIGACTION
     signal(sig, sigusr2_handle);	/* reinstall */
 #endif
@@ -415,6 +420,7 @@
 void
 sig_child(int sig)
 {
+#ifndef _SQUID_MSWIN_
 #ifdef _SQUID_NEXT_
     union wait status;
 #else
@@ -435,6 +441,7 @@
     } while (pid > 0 || (pid < 0 && errno == EINTR));
     signal(sig, sig_child);
 #endif
+#endif
 }
 
 const char *
@@ -924,6 +931,9 @@
 xrename(const char *from, const char *to)
 {
     debug(21, 2) ("xrename: renaming %s to %s\n", from, to);
+#ifdef _SQUID_MSWIN_
+    remove(to);
+#endif
     if (0 == rename(from, to))
 	return 0;
     debug(21, errno == ENOENT ? 2 : 1) ("xrename: Cannot rename %s to %s: %s\n",
@@ -966,9 +976,6 @@
     char buf2[512];
     char *nt = buf;
     char *lt = buf;
-#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-    char *systemroot = NULL;
-#endif
     if (NULL == Config.etcHostsPath)
 	return;
     if (0 == strcmp(Config.etcHostsPath, "none"))
